"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __await = (this && this.__await) || function (v) { return this instanceof __await ? (this.v = v, this) : new __await(v); }
var __asyncGenerator = (this && this.__asyncGenerator) || function (thisArg, _arguments, generator) {
    if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
    var g = generator.apply(thisArg, _arguments || []), i, q = [];
    return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
    function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
    function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
    function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
    function fulfill(value) { resume("next", value); }
    function reject(value) { resume("throw", value); }
    function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
};
Object.defineProperty(exports, "__esModule", { value: true });
var Gateway_1 = require("./Gateway");
var Qiita = /** @class */ (function (_super) {
    __extends(Qiita, _super);
    function Qiita() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        /**
         * 与えられた認証情報をもとに新しいアクセストークンを発行します。
         * @param client_id 登録されたAPIクライアントを特定するためのID
         * @param client_secret 登録されたAPIクライアントを認証するための秘密鍵
         * @param code リダイレクト用のURLに付与された、アクセストークンと交換するための文字列
         * @return アクセストークン
         */
        _this.fetchAccessToken = function (client_id, client_secret, code) {
            return _this.post("" + _this.url + _this.version + "/access_tokens", {
                client_id: client_id,
                client_secret: client_secret,
                code: code,
            });
        };
        /**
         * 指定されたアクセストークンを失効させ、それ以降利用できないようにします。
         * @param token アクセストークン
         * @return 空のオブジェクト
         */
        _this.deleteAccessToken = function (token) {
            return _this.delete("" + _this.url + _this.version + "/access_tokens/" + token);
        };
        /**
         * コメントを取得します。
         * @param comment_id コメントのID
         * @return コメントのエンティティを返します
         */
        _this.fetchComment = function (comment_id) {
            return _this.get("" + _this.url + _this.version + "/comments/" + comment_id);
        };
        /**
         * コメントを更新します。
         * @param comment_id コメントのID
         * @param body コメントの内容を表すMarkdown形式の文字列
         */
        _this.updateComment = function (comment_id, body) {
            return _this.patch("" + _this.url + _this.version + "/comments/" + comment_id, { body: body });
        };
        /**
         * コメントを削除します。
         * @param comment_id コメントのID
         * @return 空のオブジェクト
         */
        _this.deleteComment = function (comment_id) {
            return _this.delete("" + _this.url + _this.version + "/comments/" + comment_id);
        };
        /**
         * コメントに付けられた絵文字リアクション一覧を作成日時の降順で返します。
         * @param comment_id コメントID
         * @return 絵文字リアクション
         */
        _this.fetchCommentReactions = function (comment_id) {
            return _this.get("" + _this.url + _this.version + "/comments/" + comment_id + "/reactions");
        };
        /**
         * コメントに絵文字リアクションを付けます。
         * @param comment_id コメントID
         * @param name 絵文字の識別子
         * @return 絵文字リアクション
         */
        _this.createCommentReaction = function (comment_id, name) {
            return _this.post("" + _this.url + _this.version + "/comments/" + comment_id + "/reactions", { name: name });
        };
        /**
         * コメントから絵文字リアクションを削除します。
         * @param comment_id コメントID
         * @param name 絵文字の識別子
         * @return 絵文字リアクション
         */
        _this.deleteCommentReaction = function (comment_id, name) {
            return _this.delete("" + _this.url + _this.version + "/comments/" + comment_id + "/reactions", { name: name });
        };
        /**
         * タグ一覧を作成日時の降順で返します。
         * @param options.page ページ番号 (1から100まで)
         * @param options.perPage 1ページあたりに含まれる要素数 (1から100まで)
         * @param options.sort 並び順 (countで投稿数順、nameで名前順)
         * @return タグ一覧を返す非同期反復可能オブジェクト
         */
        _this.fetchTags = function (options) {
            return _this.paginationGenerator("" + _this.url + _this.version + "/tags", options);
        };
        /**
         * タグを取得します。
         * @param tagId タグのID
         * @return タグ
         */
        _this.fetchTag = function (tag_id) {
            return _this.get("" + _this.url + _this.version + "/tags/" + tag_id);
        };
        /**
         * タグをフォローしているかどうかを調べます。
         * @param tag_id タグのID
         * @return タグ
         */
        _this.fetchTagFollowing = function (tag_id) {
            return _this.get("" + _this.url + _this.version + "/tags/" + tag_id + "/following");
        };
        /**
         * タグをフォローします。
         * @param tag_id タグのID
         * @return 空のオブジェクト
         */
        _this.followTag = function (tag_id) {
            return _this.put("" + _this.url + _this.version + "/tags/" + tag_id + "/following");
        };
        /**
         * タグをフォローします。
         * @param tag_id タグのID
         * @return 空のオブジェクト
         */
        _this.unfollowTag = function (tag_id) {
            return _this.delete("" + _this.url + _this.version + "/tags/" + tag_id + "/following");
        };
        /**
         * 指定されたタグが付けられた投稿一覧を、タグを付けた日時の降順で返します。
         * @param tag_id タグID
         * @param options.page ページ番号 (1から100まで)
         * @param options.per_page 1ページあたりに含まれる要素数 (1から100まで)
         * @return 投稿一覧を返す非同期反復可能オブジェクト
         */
        _this.fetchTaggedItems = function (tag_id, options) {
            return _this.paginationGenerator("" + _this.url + _this.version + "/tags/" + tag_id, options);
        };
        /**
         * チーム内のテンプレート一覧を返します。
         * @param options.page ページ番号 (1から100まで)
         * @param options.per_page 1ページあたりに含まれる要素数 (1から100まで)
         * @return テンプレート一覧を返す非同期反復可能オブジェクト
         */
        _this.fetchTemplates = function (options) {
            return _this.paginationGenerator("" + _this.url + _this.version + "/templates", options);
        };
        /**
         * テンプレートを取得します。
         * @param template_id テンプレートID
         * @return テンプレート
         */
        _this.fetchTempalte = function (template_id) {
            return _this.get("" + _this.url + _this.version + "/templates/" + template_id);
        };
        /**
         * [実験的] タグを検索します
         * @param q 検索クエリ文字列
         * @return タグの配列
         */
        _this.searchTags = function (q) {
            return _this.get(_this.url + "/api/tags", { q: q });
        };
        /**
         * 新しくテンプレートを作成します。
         * @param options.body テンプレートの本文
         * @param options.name テンプレートを判別するための名前
         * @param options.tags タグ一覧
         * @param options.title 生成される投稿のタイトルの雛形
         * @return テンプレート
         */
        _this.createTemplate = function (options) {
            return _this.post("" + _this.url + _this.version + "/templates", options);
        };
        /**
         * テンプレートを更新します。
         * @param options.body テンプレートの本文
         * @param options.name テンプレートを判別するための名前
         * @param options.tags タグ一覧
         * @param options.title 生成される投稿のタイトルの雛形
         * @return テンプレート
         */
        _this.updateTempalte = function (options) {
            return _this.patch("" + _this.url + _this.version + "/templates", options);
        };
        /**
         * テンプレートを削除します。
         * @param template_id テンプレートID
         * @return 空のオブジェクト
         */
        _this.deleteTemplate = function (template_id) {
            return _this.delete("" + _this.url + _this.version + "/templates/" + template_id);
        };
        /**
         * チーム内に存在するプロジェクト一覧をプロジェクト作成日時の降順で返します。
         * @param options.page ページ番号 (1から100まで)
         * @param options.per_page 1ページあたりに含まれる要素数 (1から100まで)
         * @return プロジェクト一覧
         */
        _this.fetchProjects = function (options) {
            return _this.paginationGenerator("" + _this.url + _this.version + "/projects", options);
        };
        /**
         * プロジェクトを返します。
         * @param project_id プロジェクトID
         * @return プロジェクト
         */
        _this.fetchProject = function (project_id) {
            return _this.get("" + _this.url + _this.version + "/projects/" + project_id);
        };
        /**
         * プロジェクトを新たに作成します。
         * @param options.archived このプロジェクトが進行中かどうか
         * @param options.body Markdown形式の本文
         * @param options.name プロジェクト名
         * @param options.tags 投稿に付いたタグ一覧
         * @return プロジェクト
         */
        _this.createProject = function (options) {
            return _this.post("" + _this.url + _this.version + "/projects", options);
        };
        /**
         * プロジェクトを更新します。
         * @param options.archived このプロジェクトが進行中かどうか
         * @param options.body Markdown形式の本文
         * @param options.name プロジェクト名
         * @param options.tags 投稿に付いたタグ一覧
         * @return プロジェクト
         */
        _this.updateProject = function (options) {
            return _this.patch("" + _this.url + _this.version + "/projects", options);
        };
        /**
         * プロジェクトを削除します。
         * @param project_id プロジェクトID
         * @return 空のオブジェクト
         */
        _this.deleteProject = function (project_id) {
            return _this.delete("" + _this.url + _this.version + "/projects/" + project_id);
        };
        /**
         * プロジェクトに付けられたコメント一覧を投稿日時の降順で取得します。
         * @param project_id プロジェクトのID
         * @return コメント一覧
         */
        _this.fetchProjectComments = function (project_id) {
            return _this.get("" + _this.url + _this.version + "/projects/" + project_id + "/comments");
        };
        /**
         * プロジェクトに対してコメントを投稿します。
         * @param project_id 投稿のID
         * @param body コメントの内容を表すMarkdown形式の文字列
         * @return 投稿したコメント
         */
        _this.createProjectComment = function (project_id, body) {
            return _this.post("" + _this.url + _this.version + "/projects/" + project_id + "/comments", { body: body });
        };
        /**
         * プロジェクトに付けられた絵文字リアクション一覧を作成日時の降順で返します。
         * @param project_id プロジェクトID
         * @return 絵文字リアクション一覧
         */
        _this.fetchProjectReactions = function (project_id) {
            return _this.get("" + _this.url + _this.version + "/projects/" + project_id + "/reactions");
        };
        /**
         * プロジェクトに絵文字リアクションを付けます。
         * @param project_id プロジェクトID
         * @param name 絵文字の識別子
         * @return 絵文字リアクション
         */
        _this.createProjectReaction = function (project_id, name) {
            return _this.post("" + _this.url + _this.version + "/projects/" + project_id + "/reactions", { name: name });
        };
        /**
         * プロジェクトから絵文字リアクションを削除します。
         * @param project_id プロジェクトID
         * @param name 絵文字の識別子
         * @return 絵文字リアクション
         */
        _this.deleteProjectReaction = function (project_id, name) {
            return _this.delete("" + _this.url + _this.version + "/projects/" + project_id + "/reactions", { name: name });
        };
        /**
         * 全てのユーザの一覧を作成日時の降順で取得します。
         * @param options.page ページ番号 (1から100まで)
         * @param options.per_page 1ページあたりに含まれる要素数 (1から100まで)
         * @return ユーザー一覧を返す非同期反復可能オブジェクト
         */
        _this.fetchUsers = function (options) {
            return _this.paginationGenerator("" + _this.url + _this.version + "/users", options);
        };
        /**
         * ユーザを取得します。
         * @param user_id ユーザーID
         * @return ユーザー
         */
        _this.fetchUser = function (user_id) {
            return _this.get("" + _this.url + _this.version + "/users/" + user_id);
        };
        /**
         * ユーザがフォローしているユーザ一覧を取得します。
         * @param user_id ユーザーID
         * @param options.page ページ番号 (1から100まで)
         * @param options.per_page 1ページあたりに含まれる要素数 (1から100まで)
         * @return ユーザー一覧を返す非同期反復可能オブジェクト
         */
        _this.fetchUserFollowees = function (user_id, options) {
            return _this.paginationGenerator("" + _this.url + _this.version + "/users/" + user_id + "/followees", options);
        };
        /**
         * ユーザをフォローしているユーザ一覧を取得します。
         * @param user_id ユーザーID
         * @param options.page ページ番号 (1から100まで)
         * @param options.per_page 1ページあたりに含まれる要素数 (1から100まで)
         * @return ユーザー一覧を返す非同期反復可能オブジェクト
         */
        _this.fetchUserFollowers = function (user_id, options) {
            return _this.paginationGenerator("" + _this.url + _this.version + "/users/" + user_id + "/followers", options);
        };
        /**
         * 指定されたユーザの投稿一覧を、作成日時の降順で返します。
         * @param user_id ユーザID
         * @param options.page ページ番号 (1から100まで)
         * @param options.per_page 1ページあたりに含まれる要素数 (1から100まで)
         * @return 投稿一覧を返す非同期反復可能オブジェクト
         */
        _this.fetchUserItems = function (user_id, options) {
            return _this.paginationGenerator("" + _this.url + _this.version + "/users/" + user_id + "/items", options);
        };
        /**
         * 指定されたユーザがストックした投稿一覧を、ストックした日時の降順で返します。
         * @param user_id ユーザID
         * @param options.page ページ番号 (1から100まで)
         * @param options.per_page 1ページあたりに含まれる要素数 (1から100まで)
         * @return 投稿一覧を返す非同期反復可能オブジェクト
         */
        _this.fetchUserStocks = function (user_id, options) {
            return _this.paginationGenerator("" + _this.url + _this.version + "/users/" + user_id + "/items", options);
        };
        /**
         * ユーザがフォローしているタグ一覧をフォロー日時の降順で返します。
         * @param user_id ユーザーID
         * @param options.page ページ番号 (1から100まで)
         * @param options.per_page 1ページあたりに含まれる要素数 (1から100まで)
         * @return タグ一覧を返す非同期反復可能オブジェクト
         */
        _this.fetchUserFollowingTags = function (user_id, options) {
            return _this.paginationGenerator("" + _this.url + _this.version + "/users/" + user_id + "/following_tags", options);
        };
        /**
         * ユーザをフォローしている場合に204を返します。
         * @param user_id ユーザーID
         * @return 空のオブジェクト
         */
        _this.fetchIfUserFollowing = function (user_id) {
            return _this.get("" + _this.url + _this.version + "/users/" + user_id + "/following");
        };
        /**
         * ユーザをフォローします
         * @param user_id ユーザーID
         * @return 空のオブジェクト
         */
        _this.followUser = function (user_id) {
            return _this.put("" + _this.url + _this.version + "/users/" + user_id + "/following");
        };
        /**
         * ユーザへのフォローを外します。
         * @param user_id ユーザーID
         * @return 空のオブジェクト
         */
        _this.unfollowUser = function (user_id) {
            return _this.delete("" + _this.url + _this.version + "/users/" + user_id + "/following");
        };
        /**
         * 投稿の一覧を作成日時の降順で返します。
         * @param options.page ページ番号 (1から100まで)
         * @param options.per_page 1ページあたりに含まれる要素数 (1から100まで)
         * @param options.query 検索クエリ
         * @return 投稿一覧を返す非同期反復可能オブジェクト
         */
        _this.fetchItems = function (options) {
            return _this.paginationGenerator("" + _this.url + _this.version + "/items", options);
        };
        /**
         * 投稿を取得します。
         * @param item_id 投稿ID
         * @return 投稿
         */
        _this.fetchItem = function (item_id) {
            return _this.get("" + _this.url + _this.version + "/items/" + item_id);
        };
        /**
         * 新たに投稿を作成します。
         * @param options.body Markdown形式の本文
         * @param options.coediting この投稿が共同更新状態かどうか (Qiita:Teamでのみ有効)
         * @param options.gist 本文中のコードをGistに投稿するかどうか (GitHub連携を有効化している場合のみ有効)
         * @param options.groupUrlName この投稿を公開するグループの url_name (null で全体に公開。Qiita:Teamでのみ有効)
         * @param options.private 限定共有状態かどうかを表すフラグ (Qiita:Teamでは無効)
         * @param options.tag 投稿に付いたタグ一覧
         * @param options.title 投稿のタイトル
         * @param options.tweet Twitterに投稿するかどうか (Twitter連携を有効化している場合のみ有効)
         * @return 投稿
         */
        _this.createItem = function (options) {
            return _this.post("" + _this.url + _this.version + "/items", options);
        };
        /**
         * 投稿を更新します。
         * @param item_id 投稿のID
         * @param options.coediting この投稿が共同更新状態かどうか (Qiita:Teamでのみ有効)
         * @param options.groupUrlName この投稿を公開するグループの url_name (null で全体に公開。Qiita:Teamでのみ有効)
         * @param options.private 限定共有状態かどうかを表すフラグ (Qiita:Teamでは無効)
         * @param options.tag 投稿に付いたタグ一覧
         * @param options.title 投稿のタイトル
         * @return 投稿
         */
        _this.updateItem = function (item_id, options) {
            return _this.patch("" + _this.url + _this.version + "/items/" + item_id, options);
        };
        /**
         * 投稿を削除します。
         * @param item_id 投稿ID
         * @return 空のオブジェクト
         */
        _this.deleteItem = function (item_id) {
            return _this.delete("" + _this.url + _this.version + "/items/" + item_id);
        };
        /**
         * 投稿に「いいね！」を付けているかどうかを調べます。
         * @param item_id 投稿ID
         * @return 空のオブジェクト
         */
        _this.fetchIfItemLiked = function (item_id) {
            return _this.get("" + _this.url + _this.version + "/items/" + item_id + "/like");
        };
        /**
         * 投稿に「いいね！」を付けます。
         * @param item_id 投稿ID
         * @return 空のオブジェクト
         */
        _this.likeItem = function (item_id) {
            return _this.put("" + _this.url + _this.version + "/items/" + item_id + "/like");
        };
        /**
         * 投稿への「いいね！」を取り消します。
         * @param item_id 投稿ID
         * @return 空のオブジェクト
         */
        _this.unlikeItem = function (item_id) {
            return _this.delete("" + _this.url + _this.version + "/items/" + item_id + "/like");
        };
        /**
         * 投稿をストックしているかどうかを調べます。
         * @param item_id 投稿ID
         * @return 空のオブジェクト
         */
        _this.fetchIfItemStocked = function (item_id) {
            return _this.get("" + _this.url + _this.version + "/items/" + item_id + "/stock");
        };
        /**
         * 投稿をストックします。
         * @param item_id 投稿ID
         * @return 空のオブジェクト
         */
        _this.stockItem = function (item_id) {
            return _this.put("" + _this.url + _this.version + "/items/" + item_id + "/stock");
        };
        /**
         * 投稿をストックから取り除きます。
         * @param item_id 投稿ID
         * @return 空のオブジェクト
         */
        _this.unstockItem = function (item_id) {
            return _this.delete("" + _this.url + _this.version + "/items/" + item_id + "/stock");
        };
        /**
         * 記事に付けられた絵文字リアクション一覧を作成日時の降順で返します。
         * @param item_id 投稿ID
         * @return 絵文字リアクション
         */
        _this.fetchItemReactions = function (item_id) {
            return _this.post("" + _this.url + _this.version + "/items/" + item_id + "/reactions");
        };
        /**
         * 記事に絵文字リアクションを付けます。
         * @param item_id 投稿ID
         * @param name 絵文字の識別子
         * @return 絵文字リアクション
         */
        _this.createItemReaction = function (item_id, name) {
            return _this.post("" + _this.url + _this.version + "/items/" + item_id + "/reactions", { name: name });
        };
        /**
         * 記事から絵文字リアクションを削除します。
         * @param item_id 投稿ID
         * @param name 絵文字の識別子
         * @return 絵文字リアクション
         */
        _this.deleteItemReaction = function (item_id, name) {
            return _this.delete("" + _this.url + _this.version + "/items/" + item_id + "/reactions", { name: name });
        };
        /**
         * 投稿につけられた「いいね！」を作成日時の降順で返します。
         * @param item_id 投稿のID
         * @return いいね！エンティティを返します
         */
        _this.fetchItemLikes = function (item_id) {
            return _this.get("" + _this.url + _this.version + "/items/" + item_id + "/likes");
        };
        /**
         * 投稿をストックしているユーザ一覧を、ストックした日時の降順で返します。
         * @param options.page ページ番号 (1から100まで)
         * @param options.per_page 1ページあたりに含まれる要素数 (1から100まで)
         * @return ユーザー一覧を返す非同期反復可能オブジェクト
         */
        _this.fetchItemStockers = function (item_id, options) {
            return _this.paginationGenerator("" + _this.url + _this.version + "/items/" + item_id + "/stockers", options);
        };
        /**
         * 投稿に付けられたコメント一覧を投稿日時の降順で取得します。
         * @param item_id 投稿のID
         * @return コメント一覧
         */
        _this.fetchItemComments = function (item_id) {
            return _this.get("" + _this.url + _this.version + "/items/" + item_id + "/comments");
        };
        /**
         * 投稿に対してコメントを投稿します。
         * @param item_id 投稿のID
         * @param body コメントの内容を表すMarkdown形式の文字列
         * @return 投稿したコメント
         */
        _this.createItemComment = function (item_id, body) {
            return _this.post("" + _this.url + _this.version + "/items/" + item_id + "/comments", { body: body });
        };
        /**
         * 投稿にタグを追加します。Qiita:Teamでのみ有効です。
         * @param item_id 投稿のID
         * @param name タグを特定するための一意な名前
         * @param versions (説明なし)
         */
        _this.addItemTag = function (item_id, name, versions) {
            return _this.post("" + _this.url + _this.version + "/items/" + item_id + "/taggings", { name: name, versions: versions });
        };
        /**
         * 投稿から指定されたタグを取り除きます。Qiita:Teamでのみ有効です。
         * @param item_id 投稿のID
         * @param tagId タギングのID
         * @return 空のオブジェクト
         */
        _this.removeItemTag = function (item_id, tagId) {
            return _this.delete("" + _this.url + _this.version + "/items/" + item_id + "/taggings/" + tagId);
        };
        /**
         * ユーザが所属している全てのチームを、チーム作成日時の降順で返します。
         * @return チーム一覧
         */
        _this.fetchTeams = function () {
            return _this.get("" + _this.url + _this.version + "/teams");
        };
        /**
         * 招待中のメンバーの一覧を返します
         * @return 招待
         */
        _this.fetchTeamInvitations = function () {
            return _this.get("" + _this.url + _this.version + "/team_invitations");
        };
        /**
         * チームにメンバーを招待します
         * @return 招待
         */
        _this.createTeamInvitations = function () {
            return _this.post("" + _this.url + _this.version + "/team_invitations");
        };
        /**
         * 招待を取り消します
         * @return 空のオブジェクト
         */
        _this.deleteTeamInvitation = function () {
            return _this.delete("" + _this.url + _this.version + "/team_invitations");
        };
        /**
         * アクセストークンに紐付いたユーザを返します。
         * @return 認証中のユーザ
         */
        _this.fetchAuthenticatedUser = function () {
            return _this.get("" + _this.url + _this.version + "/authenticated_user");
        };
        /**
         * 認証中のユーザの投稿の一覧を作成日時の降順で返します。
         * @param options.page ページ番号 (1から100まで)
         * @param options.per_page 1ページあたりに含まれる要素数 (1から100まで)
         * @return 投稿一覧を返す非同期反復可能オブジェクト
         */
        _this.fetchAuthenticatedUserItems = function (options) {
            return _this.paginationGenerator("" + _this.url + _this.version + "/authenticated_user/items", options);
        };
        /**
         * `Qiita.fetchAuthenticatedUser` のシノニムです
         * @return 認証中のユーザ
         */
        _this.fetchMe = function () { return _this.fetchAuthenticatedUser(); };
        /**
         * `Qiita.fetchAuthenticatedUserItems` のシノニムです
         * @param options.page ページ番号 (1から100まで)
         * @param options.per_page 1ページあたりに含まれる要素数 (1から100まで)
         * @return 投稿一覧を返す非同期反復可能オブジェクト
         */
        _this.fetchMyItems = function (options) { return _this.fetchAuthenticatedUserItems(options); };
        return _this;
    }
    /**
     * Qiita APIのページネーションをラップする非同期反復可能オブジェクトを返します
     * nextの引数に文字列 'reset' を渡すと最初のインデックスに戻ることができます。
     * @param url リクエストするURL
     * @param options リクエストのオプション
     */
    Qiita.prototype.paginationGenerator = function (url, options) {
        return __asyncGenerator(this, arguments, function paginationGenerator_1() {
            var page, data, result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        page = 1;
                        _a.label = 1;
                    case 1:
                        if (!true) return [3 /*break*/, 5];
                        return [4 /*yield*/, __await(this.get(url, __assign({}, options, { page: page })))];
                    case 2:
                        data = _a.sent();
                        return [4 /*yield*/, __await(data)];
                    case 3: return [4 /*yield*/, _a.sent()];
                    case 4:
                        result = _a.sent();
                        if (result === 'reset') {
                            page = 1;
                        }
                        else {
                            page++;
                            // レスポンスの配列の長さがない場合にイテレーターを終了します。
                            if (!data.length) {
                                return [3 /*break*/, 5];
                            }
                        }
                        return [3 /*break*/, 1];
                    case 5: return [2 /*return*/];
                }
            });
        });
    };
    return Qiita;
}(Gateway_1.Gateway));
exports.Qiita = Qiita;
//# sourceMappingURL=Qiita.js.map