"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var node_fetch_1 = require("node-fetch");
var queryString = require("query-string");
var Qiita = /** @class */ (function () {
    function Qiita() {
        var _this = this;
        this.token = '';
        this.endpoint = 'https://qiita.com';
        this.version = '/api/v2';
        /**
         * Fetch APIのラッパー関数です．
         * 環境依存で `window.fetch` と `node-fetch` を切り替えます
         * @param url `fetch()` の第一引数です
         * @param options `fetch()` の第二引数です
         * @return レスポンスをパースしたリテラル/オブジェクトを返すPromiseを返します
         */
        this.request = function (url, options) {
            if (options === void 0) { options = {}; }
            return __awaiter(_this, void 0, void 0, function () {
                var response, data, error_1;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            options = __assign({}, options);
                            if (options.headers === undefined) {
                                options.headers = {};
                            }
                            if (this.token) {
                                options.headers.Authorization = "Bearer " + this.token;
                            }
                            options.headers['Content-Type'] = 'application/json';
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 7, , 8]);
                            response = void 0;
                            if (!(typeof window === 'undefined')) return [3 /*break*/, 3];
                            return [4 /*yield*/, node_fetch_1.default(url, options)];
                        case 2:
                            response = _a.sent();
                            return [3 /*break*/, 5];
                        case 3: return [4 /*yield*/, fetch(url, options)];
                        case 4:
                            response = _a.sent();
                            _a.label = 5;
                        case 5: return [4 /*yield*/, response.json()];
                        case 6:
                            data = _a.sent();
                            if (response.ok) {
                                return [2 /*return*/, data];
                            }
                            throw data;
                        case 7:
                            error_1 = _a.sent();
                            throw error_1.message ?
                                error_1 :
                                { message: '予期せぬエラー', type: 'api_client_error' };
                        case 8: return [2 /*return*/];
                    }
                });
            });
        };
        /**
         * HTTP GET のラッパー関数です
         * @param url リクエストのエンドポイントです
         * @param params オブジェクトを指定すると，query stringに文字列化してURLの末尾に付与します
         * @param options `fetch()` の第二引数です
         * @return レスポンスをパースしたリテラル/オブジェクトを返すPromiseを返します
         */
        this.get = function (url, params, options) {
            if (params === void 0) { params = {}; }
            if (options === void 0) { options = {}; }
            return _this.request(url + (Object.keys(params).length ? '?' + queryString.stringify(params) : ''), __assign({ method: 'GET' }, options));
        };
        /**
         * HTTP POST のラッパー関数です
         * @param url リクエストのエンドポイントです
         * @param params オブジェクトを指定すると，JSON文字列化してbodyに付与します
         * @param options `fetch()` の第二引数です
         * @return レスポンスをパースしたリテラル/オブジェクトを返すPromiseを返します
         */
        this.post = function (url, body, options) {
            if (body === void 0) { body = {}; }
            if (options === void 0) { options = {}; }
            return _this.request(url, __assign({ method: 'POST', body: JSON.stringify(body) }, options));
        };
        /**
         * HTTP PUT のラッパー関数です
         * @param url リクエストのエンドポイントです
         * @param params オブジェクトを指定すると，JSON文字列化してbodyに付与します
         * @param options `fetch()` の第二引数です
         * @return レスポンスをパースしたリテラル/オブジェクトを返すPromiseを返します
         */
        this.put = function (url, body, options) {
            if (body === void 0) { body = {}; }
            if (options === void 0) { options = {}; }
            return _this.request(url, __assign({ method: 'PUT', body: JSON.stringify(body) }, options));
        };
        /**
         * HTTP DELETE のラッパー関数です
         * @param url リクエストのエンドポイントです
         * @param params オブジェクトを指定すると，JSON文字列化してbodyに付与します
         * @param options `fetch()` の第二引数です
         * @return レスポンスをパースしたリテラル/オブジェクトを返すPromiseを返します
         */
        this.delete = function (url, body, options) {
            if (body === void 0) { body = {}; }
            if (options === void 0) { options = {}; }
            return _this.request(url, __assign({ method: 'DELETE', body: JSON.stringify(body) }, options));
        };
        /**
         * HTTP PATCH のラッパー関数です
         * @param url リクエストのエンドポイントです
         * @param params オブジェクトを指定すると，JSON文字列化してbodyに付与します
         * @param options `fetch()` の第二引数です
         * @return レスポンスをパースしたリテラル/オブジェクトを返すPromiseを返します
         */
        this.patch = function (url, body, options) {
            if (body === void 0) { body = {}; }
            if (options === void 0) { options = {}; }
            return _this.request(url, __assign({ method: 'PATCH', body: JSON.stringify(body) }, options));
        };
        /**
         * 与えられた認証情報をもとに新しいアクセストークンを発行します。
         * @param clientId 登録されたAPIクライアントを特定するためのID
         * @param clientSecret 登録されたAPIクライアントを認証するための秘密鍵
         * @param code リダイレクト用のURLに付与された、アクセストークンと交換するための文字列
         * @return アクセストークン
         */
        this.fetchAccessToken = function (clientId, clientSecret, code) {
            return _this.post("" + _this.endpoint + _this.version + "/access_tokens", {
                client_id: clientId,
                client_secret: clientSecret,
                code: code,
            });
        };
        /**
         * 指定されたアクセストークンを失効させ、それ以降利用できないようにします。
         * @param token アクセストークン
         * @return 空のオブジェクト
         */
        this.deleteAccessToken = function (token) {
            return _this.delete("" + _this.endpoint + _this.version + "/access_tokens/" + token);
        };
        /**
         * コメントを取得します。
         * @param commentId コメントのID
         * @return コメントのエンティティを返します
         */
        this.fetchComment = function (commentId) {
            return _this.get("" + _this.endpoint + _this.version + "/comments/" + commentId);
        };
        /**
         * コメントを更新します。
         * @param commentId コメントのID
         * @param body コメントの内容を表すMarkdown形式の文字列
         */
        this.updateComment = function (commentId, body) {
            return _this.patch("" + _this.endpoint + _this.version + "/comments/" + commentId, { body: body });
        };
        /**
         * コメントを削除します。
         * @param commentId コメントのID
         * @return 空のオブジェクト
         */
        this.deleteComment = function (commentId) {
            return _this.delete("" + _this.endpoint + _this.version + "/comments/" + commentId);
        };
        /**
         * コメントに付けられた絵文字リアクション一覧を作成日時の降順で返します。
         * @param commentId コメントID
         * @return 絵文字リアクション
         */
        this.fetchCommentReactions = function (commentId) {
            return _this.get("" + _this.endpoint + _this.version + "/comments/" + commentId + "/reactions");
        };
        /**
         * コメントに絵文字リアクションを付けます。
         * @param commentId コメントID
         * @param name 絵文字の識別子
         * @return 絵文字リアクション
         */
        this.createCommentReaction = function (commentId, name) {
            return _this.post("" + _this.endpoint + _this.version + "/comments/" + commentId + "/reactions", { name: name });
        };
        /**
         * コメントから絵文字リアクションを削除します。
         * @param commentId コメントID
         * @param name 絵文字の識別子
         * @return 絵文字リアクション
         */
        this.deleteCommentReaction = function (commentId, name) {
            return _this.delete("" + _this.endpoint + _this.version + "/comments/" + commentId + "/reactions", { name: name });
        };
        /**
         * タグ一覧を作成日時の降順で返します。
         * @param page ページ番号 (1から100まで)
         * @param perPage 1ページあたりに含まれる要素数 (1から100まで)
         * @param sort 並び順 (countで投稿数順、nameで名前順)
         * @return タグ一覧
         */
        this.fetchTags = function (page, perPage, sort) {
            return _this.get("" + _this.endpoint + _this.version + "/tags", {
                page: page,
                per_page: perPage,
                sort: sort,
            });
        };
        /**
         * タグを取得します。
         * @param tagId タグのID
         * @return タグ
         */
        this.fetchTag = function (tagId) {
            return _this.get("" + _this.endpoint + _this.version + "/tags/" + tagId);
        };
        /**
         * タグをフォローしているかどうかを調べます。
         * @param tagId タグのID
         * @return タグ
         */
        this.checkIfFollowingTag = function (tagId) {
            return _this.get("" + _this.endpoint + _this.version + "/tags/" + tagId + "/following");
        };
        /**
         * タグをフォローします。
         * @param tagId タグのID
         * @return 空のオブジェクト
         */
        this.followTag = function (tagId) {
            return _this.put("" + _this.endpoint + _this.version + "/tags/" + tagId + "/following");
        };
        /**
         * タグをフォローします。
         * @param tagId タグのID
         * @return 空のオブジェクト
         */
        this.unfollowTag = function (tagId) {
            return _this.delete("" + _this.endpoint + _this.version + "/tags/" + tagId + "/following");
        };
        /**
         * 指定されたタグが付けられた投稿一覧を、タグを付けた日時の降順で返します。
         * @param tagId タグID
         * @param page ページ番号 (1から100まで)
         * @param perPage 1ページあたりに含まれる要素数 (1から100まで)
         * @return 投稿一覧
         */
        this.fetchTaggedItems = function (tagId, page, perPage) {
            return _this.get("" + _this.endpoint + _this.version + "/tags/" + tagId, {
                page: page,
                per_page: perPage,
            });
        };
        /**
         * チーム内のテンプレート一覧を返します。
         * @param page ページ番号 (1から100まで)
         * @param perPage 1ページあたりに含まれる要素数 (1から100まで)
         * @return テンプレート一覧
         */
        this.fetchTemplates = function (page, perPage) {
            return _this.get("" + _this.endpoint + _this.version + "/templates", {
                page: page,
                per_page: perPage,
            });
        };
        /**
         * テンプレートを取得します。
         * @param tempalteId テンプレートID
         * @return テンプレート
         */
        this.fetchTempalte = function (templateId) {
            return _this.get("" + _this.endpoint + _this.version + "/templates/" + templateId);
        };
        /**
         * 新しくテンプレートを作成します。
         * @param body テンプレートの本文
         * @param name テンプレートを判別するための名前
         * @param tags タグ一覧
         * @param title 生成される投稿のタイトルの雛形
         * @return テンプレート
         */
        this.createTemplate = function (body, name, tags, title) {
            return _this.post("" + _this.endpoint + _this.version + "/templates", { body: body, name: name, tags: tags, title: title });
        };
        /**
         * テンプレートを更新します。
         * @param body テンプレートの本文
         * @param name テンプレートを判別するための名前
         * @param tags タグ一覧
         * @param title 生成される投稿のタイトルの雛形
         * @return テンプレート
         */
        this.updateTempalte = function (body, name, tags, title) {
            return _this.patch("" + _this.endpoint + _this.version + "/templates", { body: body, name: name, tags: tags, title: title });
        };
        /**
         * テンプレートを削除します。
         * @param templateId テンプレートID
         * @return 空のオブジェクト
         */
        this.deleteTemplate = function (templateId) {
            return _this.delete("" + _this.endpoint + _this.version + "/templates/" + templateId);
        };
        /**
         * チーム内に存在するプロジェクト一覧をプロジェクト作成日時の降順で返します。
         * @param page ページ番号 (1から100まで)
         * @param perPage 1ページあたりに含まれる要素数 (1から100まで)
         * @return プロジェクト一覧
         */
        this.fetchProjects = function (page, perPage) {
            return _this.get("" + _this.endpoint + _this.version + "/projects", {
                page: page,
                per_page: perPage,
            });
        };
        /**
         * プロジェクトを返します。
         * @param projectId プロジェクトID
         * @return プロジェクト
         */
        this.fetchProject = function (projectId) {
            return _this.get("" + _this.endpoint + _this.version + "/projects/" + projectId);
        };
        /**
         * プロジェクトを新たに作成します。
         * @param archived このプロジェクトが進行中かどうか
         * @param body Markdown形式の本文
         * @param name プロジェクト名
         * @param tags 投稿に付いたタグ一覧
         * @return プロジェクト
         */
        this.createProject = function (archived, body, name, tags) {
            return _this.post("" + _this.endpoint + _this.version + "/projects", { archived: archived, body: body, name: name, tags: tags });
        };
        /**
         * プロジェクトを更新します。
         * @param archived このプロジェクトが進行中かどうか
         * @param body Markdown形式の本文
         * @param name プロジェクト名
         * @param tags 投稿に付いたタグ一覧
         * @return プロジェクト
         */
        this.updateProject = function (archived, body, name, tags) {
            return _this.patch("" + _this.endpoint + _this.version + "/projects", { archived: archived, body: body, name: name, tags: tags });
        };
        /**
         * プロジェクトを削除します。
         * @param projectId プロジェクトID
         * @return 空のオブジェクト
         */
        this.deleteProject = function (projectId) {
            return _this.delete("" + _this.endpoint + _this.version + "/projects/" + projectId);
        };
        /**
         * プロジェクトに付けられたコメント一覧を投稿日時の降順で取得します。
         * @param projectId プロジェクトのID
         * @return コメント一覧
         */
        this.fetchProjectComments = function (projectId) {
            return _this.get("" + _this.endpoint + _this.version + "/projects/" + projectId + "/comments");
        };
        /**
         * プロジェクトに対してコメントを投稿します。
         * @param projectId 投稿のID
         * @param body コメントの内容を表すMarkdown形式の文字列
         * @return 投稿したコメント
         */
        this.createProjectComment = function (projectId, body) {
            return _this.post("" + _this.endpoint + _this.version + "/projects/" + projectId + "/comments", { body: body });
        };
        /**
         * プロジェクトに付けられた絵文字リアクション一覧を作成日時の降順で返します。
         * @param projectId プロジェクトID
         * @return 絵文字リアクション一覧
         */
        this.fetchProjectReactions = function (projectId) {
            return _this.get("" + _this.endpoint + _this.version + "/projects/" + projectId + "/reactions");
        };
        /**
         * プロジェクトに絵文字リアクションを付けます。
         * @param projectId プロジェクトID
         * @param name 絵文字の識別子
         * @return 絵文字リアクション
         */
        this.createProjectReaction = function (projectId, name) {
            return _this.post("" + _this.endpoint + _this.version + "/projects/" + projectId + "/reactions", { name: name });
        };
        /**
         * プロジェクトから絵文字リアクションを削除します。
         * @param projectId プロジェクトID
         * @param name 絵文字の識別子
         * @return 絵文字リアクション
         */
        this.deleteProjectReaction = function (projectId, name) {
            return _this.delete("" + _this.endpoint + _this.version + "/projects/" + projectId + "/reactions", { name: name });
        };
        /**
         * 全てのユーザの一覧を作成日時の降順で取得します。
         * @param page ページ番号 (1から100まで)
         * @param perPage 1ページあたりに含まれる要素数 (1から100まで)
         * @return ユーザー一覧
         */
        this.fetchUsers = function (page, perPage) {
            return _this.get("" + _this.endpoint + _this.version + "/users", {
                page: page,
                per_page: perPage,
            });
        };
        /**
         * ユーザを取得します。
         * @param userId ユーザーID
         * @return ユーザー
         */
        this.fetchUser = function (userId) {
            return _this.get("" + _this.endpoint + _this.version + "/users/" + userId);
        };
        /**
         * ユーザがフォローしているユーザ一覧を取得します。
         * @param userId ユーザーID
         * @param page ページ番号 (1から100まで)
         * @param perPage 1ページあたりに含まれる要素数 (1から100まで)
         * @return ユーザー一覧
         */
        this.fetchUserFollowees = function (userId, page, perPage) {
            return _this.get("" + _this.endpoint + _this.version + "/users/" + userId + "/followees", {
                page: page,
                per_page: perPage,
            });
        };
        /**
         * ユーザをフォローしているユーザ一覧を取得します。
         * @param userId ユーザーID
         * @param page ページ番号 (1から100まで)
         * @param perPage 1ページあたりに含まれる要素数 (1から100まで)
         * @return ユーザー一覧
         */
        this.fetchUserFollowers = function (userId, page, perPage) {
            return _this.get("" + _this.endpoint + _this.version + "/users/" + userId + "/followers", {
                page: page,
                per_page: perPage,
            });
        };
        /**
         * 指定されたユーザの投稿一覧を、作成日時の降順で返します。
         * @param userId ユーザID
         * @param page ページ番号 (1から100まで)
         * @param perPage 1ページあたりに含まれる要素数 (1から100まで)
         * @return 投稿一覧
         */
        this.fetchUserItems = function (userId, page, perPage) {
            return _this.get("" + _this.endpoint + _this.version + "/users/" + userId + "/items", {
                page: page,
                per_page: perPage,
            });
        };
        /**
         * 指定されたユーザがストックした投稿一覧を、ストックした日時の降順で返します。
         * @param userId ユーザID
         * @param page ページ番号 (1から100まで)
         * @param perPage 1ページあたりに含まれる要素数 (1から100まで)
         * @return 投稿一覧
         */
        this.fetchUserStocks = function (userId, page, perPage) {
            return _this.get("" + _this.endpoint + _this.version + "/users/" + userId + "/items", {
                page: page,
                per_page: perPage,
            });
        };
        /**
         * ユーザがフォローしているタグ一覧をフォロー日時の降順で返します。
         * @param userId ユーザーID
         * @param page ページ番号 (1から100まで)
         * @param perPage 1ページあたりに含まれる要素数 (1から100まで)
         * @return タグ一覧
         */
        this.fetchUserFollowingTags = function (userId, page, perPage) {
            return _this.get("" + _this.endpoint + _this.version + "/users/" + userId + "/following_tags", {
                page: page,
                per_page: perPage,
            });
        };
        /**
         * ユーザをフォローしている場合に204を返します。
         * @param userId ユーザーID
         * @return 空のオブジェクト
         */
        this.checkIfFollowingUser = function (userId) {
            return _this.get("" + _this.endpoint + _this.version + "/users/" + userId + "/following");
        };
        /**
         * ユーザをフォローします
         * @param userId ユーザーID
         * @return 空のオブジェクト
         */
        this.followUser = function (userId) {
            return _this.put("" + _this.endpoint + _this.version + "/users/" + userId + "/following");
        };
        /**
         * ユーザへのフォローを外します。
         * @param userId ユーザーID
         * @return 空のオブジェクト
         */
        this.unfollowUser = function (userId) {
            return _this.delete("" + _this.endpoint + _this.version + "/users/" + userId + "/following");
        };
        /**
         * 投稿の一覧を作成日時の降順で返します。
         * @param page ページ番号 (1から100まで)
         * @param perPage 1ページあたりに含まれる要素数 (1から100まで)
         * @param query 検索クエリ
         * @return 投稿一覧
         */
        this.fetchItems = function (page, perPage, query) {
            return _this.get("" + _this.endpoint + _this.version + "/items", {
                page: page,
                per_page: perPage,
                query: query,
            });
        };
        /**
         * 投稿を取得します。
         * @param itemId 投稿ID
         * @return 投稿
         */
        this.fetchItem = function (itemId) {
            return _this.get("" + _this.endpoint + _this.version + "/items/" + itemId);
        };
        /**
         * 新たに投稿を作成します。
         * @param params.body Markdown形式の本文
         * @param params.coediting この投稿が共同更新状態かどうか (Qiita:Teamでのみ有効)
         * @param params.gist 本文中のコードをGistに投稿するかどうか (GitHub連携を有効化している場合のみ有効)
         * @param params.groupUrlName この投稿を公開するグループの url_name (null で全体に公開。Qiita:Teamでのみ有効)
         * @param params.private 限定共有状態かどうかを表すフラグ (Qiita:Teamでは無効)
         * @param params.tag 投稿に付いたタグ一覧
         * @param params.title 投稿のタイトル
         * @param params.tweet Twitterに投稿するかどうか (Twitter連携を有効化している場合のみ有効)
         * @return 投稿
         */
        this.createItem = function (params) {
            return _this.post("" + _this.endpoint + _this.version + "/items", {
                body: params.body,
                coediting: params.coediting,
                gist: params.gist,
                group_url_name: params.groupUrlName,
                private: params.private,
                tags: params.tags,
                title: params.title,
                tweet: params.tweet,
            });
        };
        /**
         * 投稿を更新します。
         * @param itemId 投稿のID
         * @param params.coediting この投稿が共同更新状態かどうか (Qiita:Teamでのみ有効)
         * @param params.groupUrlName この投稿を公開するグループの url_name (null で全体に公開。Qiita:Teamでのみ有効)
         * @param params.private 限定共有状態かどうかを表すフラグ (Qiita:Teamでは無効)
         * @param params.tag 投稿に付いたタグ一覧
         * @param params.title 投稿のタイトル
         * @return 投稿
         */
        this.updateItem = function (itemId, params) {
            return _this.patch("" + _this.endpoint + _this.version + "/items/" + itemId, {
                body: params.body,
                coediting: params.coediting,
                group_url_name: params.groupUrlName,
                private: params.private,
                tags: params.tags,
                title: params.title,
            });
        };
        /**
         * 投稿を削除します。
         * @param itemId 投稿ID
         * @return 空のオブジェクト
         */
        this.deleteItem = function (itemId) {
            return _this.delete("" + _this.endpoint + _this.version + "/items/" + itemId);
        };
        /**
         * 投稿に「いいね！」を付けているかどうかを調べます。
         * @param itemId 投稿ID
         * @return 空のオブジェクト
         */
        this.checkIfLikedItem = function (itemId) {
            return _this.get("" + _this.endpoint + _this.version + "/items/" + itemId + "/like");
        };
        /**
         * 投稿に「いいね！」を付けます。
         * @param itemId 投稿ID
         * @return 空のオブジェクト
         */
        this.likeItem = function (itemId) {
            return _this.put("" + _this.endpoint + _this.version + "/items/" + itemId + "/like");
        };
        /**
         * 投稿への「いいね！」を取り消します。
         * @param itemId 投稿ID
         * @return 空のオブジェクト
         */
        this.unlikeItem = function (itemId) {
            return _this.delete("" + _this.endpoint + _this.version + "/items/" + itemId + "/like");
        };
        /**
         * 投稿をストックしているかどうかを調べます。
         * @param itemId 投稿ID
         * @return 空のオブジェクト
         */
        this.checkIfStockedItem = function (itemId) {
            return _this.get("" + _this.endpoint + _this.version + "/items/" + itemId + "/stock");
        };
        /**
         * 投稿をストックします。
         * @param itemId 投稿ID
         * @return 空のオブジェクト
         */
        this.stockItem = function (itemId) {
            return _this.put("" + _this.endpoint + _this.version + "/items/" + itemId + "/stock");
        };
        /**
         * 投稿をストックから取り除きます。
         * @param itemId 投稿ID
         * @return 空のオブジェクト
         */
        this.unstockItem = function (itemId) {
            return _this.delete("" + _this.endpoint + _this.version + "/items/" + itemId + "/stock");
        };
        /**
         * 記事に付けられた絵文字リアクション一覧を作成日時の降順で返します。
         * @param itemId 投稿ID
         * @return 絵文字リアクション
         */
        this.fetchItemReactions = function (itemId) {
            return _this.post("" + _this.endpoint + _this.version + "/items/" + itemId + "/reactions");
        };
        /**
         * 記事に絵文字リアクションを付けます。
         * @param itemId 投稿ID
         * @param name 絵文字の識別子
         * @return 絵文字リアクション
         */
        this.createItemReaction = function (itemId, name) {
            return _this.post("" + _this.endpoint + _this.version + "/items/" + itemId + "/reactions", { name: name });
        };
        /**
         * 記事から絵文字リアクションを削除します。
         * @param itemId 投稿ID
         * @param name 絵文字の識別子
         * @return 絵文字リアクション
         */
        this.deleteItemReaction = function (itemId, name) {
            return _this.delete("" + _this.endpoint + _this.version + "/items/" + itemId + "/reactions", { name: name });
        };
        /**
         * 投稿につけられた「いいね！」を作成日時の降順で返します。
         * @param itemId 投稿のID
         * @return いいね！エンティティを返します
         */
        this.fetchItemLikes = function (itemId) {
            return _this.get("" + _this.endpoint + _this.version + "/items/" + itemId + "/likes");
        };
        /**
         * 投稿をストックしているユーザ一覧を、ストックした日時の降順で返します。
         * @param page ページ番号 (1から100まで)
         * @param perPage 1ページあたりに含まれる要素数 (1から100まで)
         * @return ユーザー一覧
         */
        this.fetchItemStockers = function (itemId, page, perPage) {
            return _this.get("" + _this.endpoint + _this.version + "/items/" + itemId + "/stockers", {
                page: page,
                per_page: perPage,
            });
        };
        /**
         * 投稿に付けられたコメント一覧を投稿日時の降順で取得します。
         * @param itemId 投稿のID
         * @return コメント一覧
         */
        this.fetchItemComments = function (itemId) {
            return _this.get("" + _this.endpoint + _this.version + "/items/" + itemId + "/comments");
        };
        /**
         * 投稿に対してコメントを投稿します。
         * @param itemId 投稿のID
         * @param body コメントの内容を表すMarkdown形式の文字列
         * @return 投稿したコメント
         */
        this.createItemComment = function (itemId, body) {
            return _this.post("" + _this.endpoint + _this.version + "/items/" + itemId + "/comments", { body: body });
        };
        /**
         * 投稿にタグを追加します。Qiita:Teamでのみ有効です。
         * @param itemId 投稿のID
         * @param name タグを特定するための一意な名前
         * @param versions (説明なし)
         */
        this.addItemTag = function (itemId, name, versions) {
            return _this.post("" + _this.endpoint + _this.version + "/items/" + itemId + "/taggings", { name: name, versions: versions });
        };
        /**
         * 投稿から指定されたタグを取り除きます。Qiita:Teamでのみ有効です。
         * @param itemId 投稿のID
         * @param tagId タギングのID
         * @return 空のオブジェクト
         */
        this.removeItemTag = function (itemId, tagId) {
            return _this.delete("" + _this.endpoint + _this.version + "/items/" + itemId + "/taggings/" + tagId);
        };
        /**
         * ユーザが所属している全てのチームを、チーム作成日時の降順で返します。
         * @return チーム一覧
         */
        this.fetchTeams = function () {
            return _this.get("" + _this.endpoint + _this.version + "/teams");
        };
        /**
         * 招待中のメンバーの一覧を返します
         * @return 招待
         */
        this.fetchTeamInvitations = function () {
            return _this.get("" + _this.endpoint + _this.version + "/team_invitations");
        };
        /**
         * チームにメンバーを招待します
         * @return 招待
         */
        this.createTeamInvitations = function () {
            return _this.post("" + _this.endpoint + _this.version + "/team_invitations");
        };
        /**
         * 招待を取り消します
         * @return 空のオブジェクト
         */
        this.deleteTeamInvitation = function () {
            return _this.delete("" + _this.endpoint + _this.version + "/team_invitations");
        };
        /**
         * アクセストークンに紐付いたユーザを返します。
         * @return 認証中のユーザ
         */
        this.fetchMe = function () {
            return _this.get("" + _this.endpoint + _this.version + "/authenticated_user");
        };
        /**
         * 認証中のユーザの投稿の一覧を作成日時の降順で返します。
         * @param page ページ番号 (1から100まで)
         * @param perPage 1ページあたりに含まれる要素数 (1から100まで)
         * @return 投稿一覧
         */
        this.fetchMyItems = function (page, perPage) {
            return _this.get("" + _this.endpoint + _this.version + "/authenticated_user/items", {
                page: page,
                per_page: perPage,
            });
        };
    }
    /**
     * Qiita APIにアクセスするためのトークンを設定します
     * @param token トークン文字列
     * @return 何も返しません
     */
    Qiita.prototype.setToken = function (token) {
        this.token = token;
    };
    /**
     * Qiita Teamへのエンドポイントを設定します
     * @param endpoint エンドポイントへのURI
     * @return 何も返しません
     */
    Qiita.prototype.setEndpoint = function (endpoint) {
        this.endpoint = endpoint;
    };
    /**
     * Qiita APIへのパスを指定します．
     * @param version APIへのパスの文字列 (e.g. `/api/v2`)
     * @return 何も返しません
     */
    Qiita.prototype.setVersion = function (version) {
        this.version = version;
    };
    return Qiita;
}());
exports.Qiita = Qiita;
//# sourceMappingURL=qiita.js.map